##############################################################################
# PROGRAM : iWeb Module and Variable Loader                                  #
# VERSION : 5.05                                                             #
#                                                                            #
##############################################################################
#            __      __           __                                         #
#     __    /\ \  __/\ \         /\ \                                        #
#    /\_\   \ \ \/\ \ \ \     __ \ \ \____                                   #
#    \/\ \   \ \ \ \ \ \ \  /'__`\\ \ '__`\                                  #
#     \ \ \   \ \ \_/ \_\ \/\  __/ \ \ \L\ \                                 #
#      \ \_\   \ `\___x___/\ \____\ \ \_,__/                                 #
#       \/_/    '\/__//__/  \/____/  \/___/                                  #
#                                                                            #
##############################################################################
# All source code, images, programs, files included in this distribution     #
# Copyright (c) 1996,1997,1998,1999,2000                                     #
#                                                                            #
#           John C. Cokos, The CCS Network, Inc.  IWeb, Inc.                 #
#           All Rights Reserved.                                             #
#                                                                            #
# Use, distibution, sale, or access to this program is forbidden without     #
# permission, except were permitted by the license agreement.                #
#                                                                            #
##############################################################################
#                                                                            #
#    ------ DO NOT MODIFY ANYTHING BELOW THIS POINT !!! -------              #
#                                                                            #
#    Modification of the souce code of this program violates the             #
#    license agreement, and terminates your right to technical support.      #
#                                                                            #
##############################################################################
#START#

   package IWEB;
   require Exporter;
   @ISA = qw(Exporter);
   @EXPORT = qw( Read_Config  Clear_All_Variables  Admin_Header  Admin_Footer  
                 Read_Language  SQL_Connect  SQL_Disconnect  SQL_ERROR  Quit  
                 iWeb_die
             );

BEGIN { 

   # Predefined Variables ... Program Wide Visibility
   use vars qw (
       $ISP $PROG_URL %global %programs %urls $cext %input %encodedform 
       $action $password %admincookie $data_dir $admin_url  $debug  $debug_text 
       $directory @dir $key $OUT $file $INUSE $LOGTEXT $cext $SQL $SERVER $BUILDING
       $out_file $new_dir $done $page $next $lib_dir $FCGI $BRANDED

       %hyperseek %HITS %ignored %language %category_matches %forbidden
       %descriptions %catrelated %metatitle %metadesc %metakeys %score
       %optional %required %screen %categories %counts %teasers %kept
       %passcookie %rules %mailed %bbs %users %iforum %user %LINKS %account
       %foruminfo %users %bannermaster %passcookie %accounts %groups %emoticons
       %terms %bannermaster %bmaccount %visitors %referers %types %results
       %categories %new %report %domains %jh %templates %price %badwordlist
       %exclude %rset %supplemental

       @rows @links @Catsplit %Count @ADD_US @DELETE_US @messages @records
       @groups @accounts @words @searched @phrases @cats @searches

       $sth $rc $dbh $sth $SQL $COOKIE  $FONT1 $FONT2 $font1 $font2
       $Remaining $rank $Next $LINK_TEMPLATE $Ignore $d $RULES
       $BR $space $http $rate_votes_db $rate_score_db
       $database $key_data $cat_db $new_db $cool_db $hits_db $top10_db 
       $TmpID $password $add $delete $LOCAL $id $commandline $msg $MASTER
       $mailedout $maildups $mailinvalid

       $ID $Category $ELink $Position $Qualifier $Email $Title $URL 
       $Description $Keys $desc_image $title_tag $site_icon $Name $Address 
       $City $State $Zip $Country $Phone $Fax $field1 $field2 $field3 $field4 
       $field5 $field6 $field7 $field8 $field9 $field10
       $startdate $enddate $price $account $xfactor $INDEX $hits $tvotes $rvotes $rscore $balance

       $forum $thread $f_matched $title $ok_msg $click $x $btext $image $BMS $CODE
       $newkey $month $key $TARGET $bad $badmsg $time $LWP $err $bad_domain
       $phrase $total_words $warning_message $valid $user

      );

}

BEGIN {

   # use sigtrap 'handler', \&iWeb_die, 'die';
   eval ("use DBI");
   eval ("use IWeb::plugins");
   eval ("use IWeb::cgitoolkit");
   eval ("use IWeb::bm");
}


IWEB::Read_Config();

sub Read_Config {


   undef $s;
   undef $w;
   undef $cnt;
   undef $ISP; 
   undef %encodedform;
   undef $action; 
   undef $password; 
   undef %admincookie; 
   undef $debug_text; 
   undef $directory; 
   undef @dir; 
   undef @group; 
   undef $key; 
   undef $OUT; 
   undef $file; 
   undef $LOGTEXT; 
   undef $SQL; 
   undef $BUILDING;
   undef $out_file; 
   undef $new_dir; 
   undef $done; 
   undef $page; 
   undef $next; 
   undef %hyperseek; 
   undef %HITS; 
   undef %ignored; 
   undef %language; 
   undef %category_matches; 
   undef %forbidden;
   undef %descriptions; 
   undef %catrelated; 
   undef %metatitle; 
   undef %metadesc; 
   undef %metakeys; 
   undef %score;
   undef %optional; 
   undef %required; 
   undef %screen; 
   undef %categories; 
   undef %counts; 
   undef %teasers; 
   undef %kept;
   undef %passcookie; 
   undef %rules; 
   undef %mailed; 
   undef %bbs; 
   undef %users; 
   undef %iforum; 
   undef %user; 
   undef %LINKS; 
   undef %account;
   undef %foruminfo; 
   undef %users; 
   undef %bannermaster; 
   undef %passcookie; 
   undef %accounts; 
   undef %groups; 
   undef %emoticons;
   undef %terms; 
   undef %bmaccount; 
   undef %visitors; 
   undef %referers; 
   undef %types; 
   undef %results;
   undef %categories; 
   undef %new; 
   undef %report;
   undef %jh;
   undef %badwordlist;
   undef %rset;
   undef %price;
   undef @rows; 
   undef @links; 
   undef @Catsplit; 
   undef %Count; 
   undef @ADD_US; 
   undef @DELETE_US; 
   undef @messages; 
   undef @records;
   undef @groups; 
   undef @accounts; 
   undef @words; 
   undef @searched; 
   undef @phrases; 
   undef @cats; 
   undef @searches;
   undef $sth; 
   undef $rc; 
   undef $SQL; 
   undef $COOKIE;  
   undef $FONT1; 
   undef $FONT2; 
   undef $font1; 
   undef $font2;
   undef $Remaining; 
   undef $rank; 
   undef $Next; 
   undef $LINK_TEMPLATE; 
   undef $Ignore; 
   undef $d; 
   undef $RULES;
   undef $BR; 
   undef $space; 
   undef $http; 
   undef $TmpID; 
   undef $password; 
   undef $add; 
   undef $delete; 
   undef $LOCAL; 
   undef $id; 
   undef $commandline; 
   undef $msg; 
   undef $MASTER;
   undef $mailedout; 
   undef $maildups; 
   undef $mailinvalid;
   undef $ID; 
   undef $Category; 
   undef $ELink; 
   undef $Position; 
   undef $Qualifier; 
   undef $Email; 
   undef $Title; 
   undef $URL; 
   undef $Description; 
   undef $Keys; 
   undef $desc_image; 
   undef $title_tag; 
   undef $site_icon; 
   undef $Name; 
   undef $Address; 
   undef $City; 
   undef $State; 
   undef $Zip; 
   undef $Country; 
   undef $Phone; 
   undef $Fax; 
   undef $startdate; 
   undef $enddate; 
   undef $price; 
   undef $account; 
   undef $xfactor; 
   undef $field1; 
   undef $field2; 
   undef $field3; 
   undef $field4; 
   undef $field5; 
   undef $field6; 
   undef $field7; 
   undef $field8; 
   undef $field9; 
   undef $field10; 
   undef $INDEX;
   undef $forum; 
   undef $thread; 
   undef $f_matched; 
   undef $title; 
   undef $ok_msg; 
   undef $click; 
   undef $x; 
   undef $btext; 
   undef $image; 
   undef $CODE;
   undef $newkey; 
   undef $month; 
   undef $key; 
   undef $TARGET; 
   undef $bad; 
   undef $badmsg; 
   undef $time; 
   undef $LWP; 
   undef $err; 
   undef $bad_domain;
   undef $phrase; 
   undef $total_words; 


   ############################################
   ## Grab Data Directory and User Settings
   ############################################

   delete $INC{"IWeb/data.pah"};
   require("IWeb/data.path");

   open(FILE,"$data_dir/global.config");
      while(<FILE>) {
        chomp;
        ($var,$val)=split(/\=/,$_,2);
        $global{$var}=$val;
      } 
   close(FILE);

   ############################################
   ## Define some of the helper urls....
   ############################################

   undef %urls;
   $cext = $global{'cgi_extension'};

      $urls{'WHATSNEW'}  = "$global{'CGI_DIR'}/admin/new_admin.$cext";
      $urls{'HYPERSEEK'} = "$global{'CGI_DIR'}/admin/hs_admin.$cext";
      $urls{'HF'}        = "$global{'CGI_DIR'}/admin/hf_admin.$cext";
      $urls{'ISEEK'}     = "$global{'CGI_DIR'}/admin/iseek_admin.$cext";
      $urls{'ILINK'}     = "$global{'CGI_DIR'}/admin/ilink_admin.$cext";
      $urls{'ISHOP'}     = "$global{'CGI_DIR'}/admin/ishop_admin.$cext";
      $urls{'WEBRING'}   = "$global{'CGI_DIR'}/admin/ring_admin.$cext";
      $urls{'GBOOK'}     = "$global{'CGI_DIR'}/admin/gb_admin.$cext";
      $urls{'COMMENTS'}  = "$global{'CGI_DIR'}/admin/cmt_admin.$cext";
      $urls{'FILES'}     = "$global{'CGI_DIR'}/admin/filex_admin.$cext";
      $urls{'BBS'}       = "$global{'CGI_DIR'}/admin/bbs_admin.$cext";
      $urls{'CLASS'}     = "$global{'CGI_DIR'}/admin/class_admin.$cext";
      $urls{'SLPAT'}     = "$global{'CGI_DIR'}/admin/splat_admin.$cext";
      $urls{'BANNERS'}   = "$global{'CGI_DIR'}/admin/bm_admin.$cext";
      $urls{'MAIL'}      = "$global{'CGI_DIR'}/admin/mailman.$cext";
      $urls{'USERS'}     = "$global{'CGI_DIR'}/admin/users.$cext";
      $urls{'ESN'}       = IWEB::Encrypt($ENV{'SERVER_NAME'});

   ############################################
   ## Define some of the helper urls....
   ############################################

   $PROG_URL = $ENV{'SCRIPT_NAME'};

   $urls{'hyperseek_url'} = $global{'hyperseek_name'};

   $admin_url = "$global{'CGI_DIR'}/admin/$global{'admin_name'}";

      $urls{'new_admin_url'}    = "$global{'CGI_DIR'}/admin/new_admin.$cext";
      $urls{'hs_admin_url'}     = "$global{'CGI_DIR'}/admin/hs_admin.$cext";
      $urls{'hf_admin_url'}     = "$global{'CGI_DIR'}/admin/hf_admin.$cext";
      $urls{'iseek_admin_url'}  = "$global{'CGI_DIR'}/admin/iseek_admin.$cext";
      $urls{'ilink_admin_url'}  = "$global{'CGI_DIR'}/admin/ilink_admin.$cext";
      $urls{'cp_admin_url'}     = "$global{'CGI_DIR'}/admin/cp_admin.$cext";
      $urls{'ishop_admin_url'}  = "$global{'CGI_DIR'}/admin/ishop_admin.$cext";
      $urls{'ring_admin_url'}   = "$global{'CGI_DIR'}/admin/ring_admin.$cext";
      $urls{'gb_admin_url'}     = "$global{'CGI_DIR'}/admin/gb_admin.$cext";
      $urls{'cmt_admin_url'}    = "$global{'CGI_DIR'}/admin/cmt_admin.$cext";
      $urls{'filex_admin_url'}  = "$global{'CGI_DIR'}/admin/filex_admin.$cext";
      $urls{'bbs_admin_url'}    = "$global{'CGI_DIR'}/admin/bbs_admin.$cext";
      $urls{'class_admin_url'}  = "$global{'CGI_DIR'}/admin/class_admin.$cext";
      $urls{'splat_admin_url'}  = "$global{'CGI_DIR'}/admin/splat_admin.$cext";
      $urls{'bm_admin_url'}     = "$global{'CGI_DIR'}/admin/bm_admin.$cext";
      $urls{'top_admin_url'}    = "$global{'CGI_DIR'}/admin/top_admin.$cext";
      $urls{'ahyperseek_url'}   = "$global{'CGI_DIR'}/admin/ahyperseek.$cext";
      $urls{'adm_add_url'}      = "$global{'CGI_DIR'}/admin/adm_add_url.$cext";
      $urls{'moderator_url'}    = "$global{'CGI_DIR'}/moderators/moderator.$cext";
      $urls{'change_url'}       = "$global{'CGI_DIR'}/change_url.$cext";
      $urls{'acp_main_url'}     = "$global{'CGI_DIR'}/admin/acp_main.$cext";
      $urls{'acp_url'}          = "$global{'CGI_DIR'}/admin/acp.$cext";
      $urls{'acp_search_url'}   = "$global{'CGI_DIR'}/admin/admin/acp_search.$cext";
      $urls{'ashop_url'}        = "$global{'CGI_DIR'}/admin/ashop.$cext";
      $urls{'ashop_search_url'} = "$global{'CGI_DIR'}/admin/ashop_search.$cext";
      $urls{'ashop_main_url'}   = "$global{'CGI_DIR'}/admin/ashop_main.$cext";
      $urls{'jackhammer_admin_url'}  = "$global{'CGI_DIR'}/admin/jackhammer_admin.$cext";

      $urls{'mailman_url'}      = "$global{'CGI_DIR'}/admin/mailman.$cext";
      $urls{'mlists_url'}       = "$global{'CGI_DIR'}/mlists.$cext";
      $urls{'faq_url'}          = "$global{'CGI_DIR'}/faq.$cext";
      $urls{'nph_mail_url'}     = "$global{'CGI_DIR'}/admin/nph-mail.$cext";
      $urls{'click_url'}        = "$global{'CGI_DIR'}/click.$cext";
      $urls{'bm_url'}           = "$global{'CGI_DIR'}/bm.$cext";
      $urls{'bms_url'}          = "$global{'CGI_DIR'}/bms.$cext";
      $urls{'report_url'}       = "$global{'CGI_DIR'}/report.$cext";

      $urls{'rateit_url'}       = "$global{'CGI_DIR'}/rateit.$cext";
      $urls{'top10_url'}        = "$global{'CGI_DIR'}/vote.$cext";
      $urls{'hsx_url'}          = "$global{'CGI_DIR'}/hsx.$cext";

      $urls{'spider_url'}       = "$global{'CGI_DIR'}/hs_spider.$cext";
      $urls{'optin_url'}        = "$global{'CGI_DIR'}/optin.$cext";
      $urls{'comments_url'}     = "$global{'CGI_DIR'}/comments.$cext";
      $urls{'hsx_searchstat'}     = "$global{'CGI_DIR'}/admin/hsx_searchstat.$cext";
      $urls{'import_url'}       = "$global{'CGI_DIR'}/admin/hs_import.$cext";
      $urls{'cat_mgr_url'}      = "$global{'CGI_DIR'}/admin/cat_mgr.$cext";
      $urls{'whatsnew_url'}     = "$global{'CGI_DIR'}/whatsnew.$cext";
      $urls{'add_url'}          = "$global{'CGI_DIR'}/add_url.$cext";

      $urls{'cpread_url'}       = "$global{'CGI_DIR'}/cpread.$cext";
      $urls{'classpro_url'}     = "$global{'CGI_DIR'}/classpro.$cext";
      $urls{'placead_url'}      = "$global{'CGI_DIR'}/place_ad.$cext";
      $urls{'cp_moderator_url'} = "$global{'CGI_DIR'}/cp_moderator.$cext";

      $urls{'ishop_url'}        = "$global{'CGI_DIR'}/ishop.$cext";
      $urls{'add_item_url'}     = "$global{'CGI_DIR'}/add_item.$cext";
      $urls{'ishop_new_url'}    = "$global{'CGI_DIR'}/ishop_new.$cext";
      $urls{'ishop_url'}        = "$global{'CGI_DIR'}/ishop.$cext";
      $urls{'issearch_url'}     = "$global{'CGI_DIR'}/issearch.$cext";
      $urls{'add_cart_url'}     = "$global{'CGI_DIR'}/add_cart.$cext";
      $urls{'ismain_url'}       = "$global{'CGI_DIR'}/ismain.$cext";
      $urls{'ishop_report_url'} = "$global{'CGI_DIR'}/ishop_report.$cext";
      $urls{'upload_url'}       = "$global{'CGI_DIR'}/upload.$cext";
      $urls{'iforum_url'}       = "$global{'CGI_DIR'}/iforum.$cext";
      $urls{'hforum_url'}       = "$global{'CGI_DIR'}/hforum.$cext";
      $urls{'bbs_upload_url'}   = "$global{'CGI_DIR'}/bbs_upload.$cext";
      $urls{'edit_post_url'}    = "$global{'CGI_DIR'}/edit_post.$cext";
      $urls{'users_url'}        = "$global{'CGI_DIR'}/users.$cext";
      $urls{'classifieds_url'}  = "$global{'CGI_DIR'}/classifieds.$cext";
      $urls{'filex_url'}        = "$global{'CGI_DIR'}/filex.$cext";
      $urls{'topgo_url'}        = "$global{'CGI_DIR'}/topgo.$cext";
      $urls{'iseek_url'}        = "$global{'CGI_DIR'}/iseek.$cext";
      $urls{'ilink_url'}        = "$global{'CGI_DIR'}/ilink.$cext";
      $urls{'iseek_add_url'}    = "$global{'CGI_DIR'}/iseek_add.$cext";
      $urls{'chat_url'}         = "$global{'CGI_DIR'}/chat.$cext";

      $urls{'seaccount_url'}    = "$global{'CGI_DIR'}/accounts/seaccount.$cext";
      $urls{'jaccount_url'}     = "$global{'CGI_DIR'}/accounts/jaccount.$cext";

      $urls{'nph_ilink'}        = "$global{'CGI_DIR'}/admin/nph-ilink.$cext";
      $urls{'nph_iseek'}        = "$global{'CGI_DIR'}/admin/nph-iseek.$cext";

      $urls{'nph_ringmaster_url'} = "$global{'CGI_DIR'}/admin/nph-ringmaster.$cext";
      $urls{'nph_hyperseek_url'} = "$global{'CGI_DIR'}/admin/nph-hyperseek.$cext";



}


sub Admin_Header {

   my ($title) = $_[0];
   my ($width) = $_[1];
   my ($help) = $_[2];

   if($help) { $help = qq! <TD BGCOLOR="#cccc99" WIDTH=1%><CENTER><A HREF="$global{'html_dir'}$help" TARGET="new"><IMG SRC="$global{'button_dir'}/help-icon.gif" BORDER=0></A></CENTER></TD> !; }
   else { $help = qq! <TD WIDTH=1% BGCOLOR="#cccc99">&nbsp;</TD>!; }

   if(! $width) { $width=550; }

   $header = qq!
      <HEAD>
         <style type="text/css">A:hover {text-decoration: on; background-color: #DBDBDB; color: #000000;}</style>
       <style>
          table        { font-family: Arial; font-size: 10pt }
          td           { font-family: Arial; font-size: 10pt }
          tr           { font-family: Arial; font-size: 10pt }
       </style>
         <script language="javascript">
             function AreYouSure(msg,loc) {
                if (confirm(msg)) {
                   self.document.location.href=loc;
                   // alert(loc);
                }
             }
         </script>
      </HEAD>

      <BODY BGCOLOR="#e0e0e0" LINK="maroon" VLINK="maroon" TEXT="black">
      <BASEFONT SIZE=-1>
        <CENTER>
      
          <TABLE BGCOLOR="white" BORDER="1" CELLPADDING="3" WIDTH=$width><TR><TD>
          <TABLE BORDER="0" CELLSPACING=0 CELLPADDING="3" WIDTH="100%">
              <TR BGCOLOR="#cccc99">
                 <TD><FONT FACE="Verdana,Arial, Helvetica" SIZE="2" COLOR="#660000" WIDTH=100%><B>$title</B></FONT></TD>
                 $help
              </TR>
              <TR>
                 <TD COLSPAN=2 BGCOLOR="#EEEEEE" VALIGN="top">
                  <FONT FACE="Arial, Helvetica" SIZE="1" COLOR="#000000">
   !; 


   return($header);

}


sub Admin_Footer {


   my ($footer) = qq!

                  <BR><BR>
                    <CENTER><A HREF="javascript:history.go(-1)">Return to previous screen</A></CENTER>
                  <BR><BR>

                  </FONT>
                </TD>
              </TR>
           </TABLE>
          </TD></TR></TABLE>
        </CENTER>
      </BODY>
   !;

   return($footer);

}





sub Read_Language {
  
  my($file) = $_[0];
  my($var,$val);      

  $file = "$data_dir/language/$global{'default_language'}/$file.pm";

  open(FILE,"$file");
    while(<FILE>) {
      chomp;
      ($var,$val)=split(/\=\=/,$_);
      $language{$var}=$val;
    } 
  close(FILE);

  $file = "$data_dir/language/$global{'default_language'}/global.pm";

  open(FILE,"$file");
    while(<FILE>) {
      chomp;
      ($var,$val)=split(/\=\=/,$_);
      $language{$var}=$val;
    } 
  close(FILE);

}


sub SQL_Connect {

   my($driver_string);      

   if($global{'dbhost'} && $global{'dbhost'} ne "localhost") {  
      $driver_string = "dbi:$global{'sql_driver'}:$global{'dbname'}:$global{'dbhost'}";
   }
   else {
      $driver_string = "dbi:$global{'sql_driver'}:$global{'dbname'}";
   }

   if($global{'sql_driver'} eq "InterBase") { $driver_string .= ";ib_dialect=3"; }

   $ENV{'DBPATH'}="/usr/informix";
   $ENV{'INFORMIXDIR'}="/usr/informix";
   $ENV{'LD_LIBRARY_PATH'}="/usr/informix/lib:/usr/informix/lib/esql"; 
   $ENV{'INFORMIXSERVER'}="iweb";

   $dbh = DBI->connect($driver_string,$global{'dbusername'},$global{'dbpassword'}) || IWEB::SQL_ERROR();

}


sub SQL_Disconnect {
   $sth->finish if($sth);
   $dbh->disconnect if($dbh);
}

sub SQL_ERROR {

    my($statement) = $_[0];
    my($error_message) = $DBI::errstr;
    my $error = IWEB::ERROR("$error_message <BR> $statement");

    if(! $hyperseek{'loading'}) {
       IWEB::iWeb_Header($error);
       IWEB::Quit();
    }

    else { print "ERR: $error_message\n"; }
}

sub Quit {

   if($FCGI) { return() }
   elsif($MOD_PERL) { Apache::exit(); }
   elsif($SERVER) { }
   else { 
     if($global{'DB_Format'} eq "SQL") { IWEB::SQL_Disconnect(); }
     exit 0;
   }

}



sub iWeb_die {

   my($error,$key);      
   my($package, $filename, $line) = caller;
   $error = $_[0];
 
   if($PROG_URL && $error ne "OK") { 
      print "Content-Type: text/html\n\n";
      $error .= "<BR>Calling Package: $package<BR>File: $filename<BR>Line:$line<HR>Environment Dump<BR>\n";
      foreach $key(keys %ENV) { 
         $error .= "<B>$key</B>: <I>$ENV{$key}</I><BR>\n"; 
      }
      print IWEB::ERROR($error); 
      IWEB::Quit();
   }
}

sub AUTOLOAD {
  
    return("<!-- Subroutine Location Error: $AUTOLOAD --> ");

}

1;

__DATA__
QIL~4+&3.A]QCliF .detrelA repoleveD .deined si sseccA .... esu ni erawtfoS deretsigernU" tnirp
